#version 100

#ifdef GL_ES
precision highp float;
#endif

varying vec2 vTexCoords;
uniform sampler2D uTextureY;
uniform int uIsRightEye;
uniform int uUseOmnistereo;

void main() {
  // Omnistereo:
  //     v_mul = 0.5, v_off = (uIsRightEye ? 0 : 0.5).
  // Otherwise:
  //     v_mul = 1, v_off = 0.
  float v_mul = mix(1.0, 0.5, float(uUseOmnistereo));
  float v_off = float(uIsRightEye) * mix(0.0, 0.5, float(uUseOmnistereo));

  // Compute texture coordinates for sampler lookup.
  float u = vTexCoords.x;
  float v = vTexCoords.y * v_mul + v_off;

  gl_FragColor = texture2D(uTextureY, vec2(u, v));
}
