// yourShader.frag
uniform sampler2D yourTexture;
precision highp float;
varying vec2 texCoord;
uniform int stereoType;
uniform int eye;

varying vec3 vDir;

#define PI 3.1415926535897932384626433832795

void main(void) {

//    float X = texCoord.x;
//    float Y = texCoord.y;

    highp float phi = atan(vDir.x, -vDir.z);
    highp float theta = atan(vDir.y, length(vDir.xz));

    highp float invTwoPi = 0.5 / PI;

    highp float X = phi * invTwoPi + 0.5;
    highp float Y = theta * invTwoPi * 2.0 + 0.5;

    if (stereoType == 1) {
        X = (X + float(eye - 1)) * 0.5;
    } else if (stereoType == 2) {
        Y = (Y + float(eye - 1)) * 0.5;
    } else if (stereoType == 3) {
        X = (X + float(2 - eye)) * 0.5;
    } else if (stereoType == 4) {
        Y = (Y + float(2 - eye)) * 0.5;
    }

    gl_FragColor = texture2D(yourTexture, vec2(X, 1.0 - Y));
}
