function findHrefLinkAtPoint(x, y) {
    e = document.elementFromPoint(x, y);
    while (e && ! e.href) {
        e = e.parentNode;
    }
    if (e && e.href) {
        return e.href;
    }
    
    return null;
}

function findElementsAtPoint(x, y) {
    e = document.elementFromPoint(x, y);
    
    var children = Array.prototype.slice.call(e.childNodes);
    children.forEach(function(child) {
        if (child.src != null && child.tagName == 'SOURCE') {
            e = child;
        }
    });
    
    while (e && !e.src) {
        e = e.parentNode;
    }
    
    var jsonResult = {};
    
    if (e && e.src) {
        if (e.tagName == 'VIDEO' || e.parentNode.tagName == 'VIDEO') {
            jsonResult["videoElement"] = {"URL": e.src, "title": e.title || e.parentNode.title};
        }
        else if (e.tagName == 'AUDIO' || e.parentNode.tagName == 'AUDIO') {
            jsonResult["audioElement"] = {"URL": e.src, "title": ""};
        }
        else if (e.tagName == 'IMG' && e.src.startsWith('http')) {
            jsonResult["imageElement"] = {"URL": e.src, "title": ""};
        }
    }

    href = findHrefLinkAtPoint(x, y);
    if (href) {
        jsonResult["hrefElement"] = {"URL": href, "title": ""};
    }
    
    webkit.messageHandlers.longPressMessageHandler.postMessage(jsonResult);
}
