(function()
{
  ext.storage = {
    callbacks: {},
    callbacksCount: 0,
    addCallback: function(callback)
    {
      ext.storage.callbacksCount++;
      ext.storage.callbacks[ext.storage.callbacksCount] = callback;
      return ext.storage.callbacksCount;
    },
    executeCallback: function(callbackNumber, data)
    {
      var callback = ext.storage.callbacks[callbackNumber];
      if (!callback)
      {
        return;
      }
      if (data)
      {
        result = {}
        for (var key in data) {
          if (data.hasOwnProperty(key)) {
            result[key] = JSON.parse(data[key])
          }
        }
        callback(result);
      }
      else
      {
        callback();
      }
    },
    get: function(keys, callback)
    {
      var message = {"keys" : keys};
      if (callback)
      {
        var callbackNumber = ext.storage.addCallback(callback);
        message.callbackNumber = callbackNumber;
      }

      webkit.messageHandlers.storageGet.postMessage(message);
    },
    set: function(key, value, callback)
    {
      var message = {
        "key" : key,
        "value" : JSON.stringify(value)
      };
      if (callback)
      {
        var callbackNumber = ext.storage.addCallback(callback);
        message.callbackNumber = callbackNumber;
      }

      webkit.messageHandlers.storageSet.postMessage(message);
    },
    remove: function(key, callback)
    {
      var message = {
        "key" : key
      };
      if (callback)
      {
        var callbackNumber = ext.storage.addCallback(callback);
        message.callbackNumber = callbackNumber;
      }

      webkit.messageHandlers.storageRemove.postMessage(message);
    },
    onChanged: new ext._EventTarget()
  };
})();
