function prepareAllElements(e) {
    prepareVideoElementInDocument(document);

    var iframes = document.getElementsByTagName('iframe');

    for (i = 0; i < iframes.length; i++) {
        iframe = iframes[i];
        if (iframe.src.match(document.domain)) {
            var innerDoc = iframe.contentDocument || iframe.contentWindow.document;

            prepareVideoElementInDocument(innerDoc);
        }
    }
}

function prepareVideoElementInDocument(document) {
    var arrayOfVideoElements = document.getElementsByTagName('video');

    for (var i = 0; i < arrayOfVideoElements.length; i++) {
        var videoElement = arrayOfVideoElements[i];
        prepareVideoElement(videoElement);
    }
}

function prepareVideoElement(videoElement) {
    videoElement.removeEventListener('webkitbeginfullscreen', onFullScreen);
    videoElement.addEventListener('webkitbeginfullscreen', onFullScreen);
    
//    videoElement.onabort = onAbort;
//    videoElement.oncanplay = onCanplay;
//    videoElement.oncanplaythrough = onCanplaythrough;
//    videoElement.ondurationchange = onDurationchange;
//    videoElement.onemptied = onEmptied;
//    videoElement.onended = onEnded;
//    videoElement.onerror = onError;
//    videoElement.onloadeddata = onLoadeddata;
//    videoElement.onloadedmetadata = onLoadedmetadata;
//    videoElement.onloadstart = onLoadstart;
//    videoElement.onpause = onPause;
//    videoElement.onplay = onPlay;
//    videoElement.onplaying = onPlaying;
//    //videoElement.onprogress = onProgress;
//    videoElement.onratechange = onRatechange;
//    videoElement.onseeked = onSeeked;
//    videoElement.onseeking = onSeeking;
//    videoElement.onstalled = onStalled;
//    videoElement.onsuspend = onSuspend;
//    //videoElement.ontimeupdate = onTimeupdate;
//    videoElement.onvolumechange = onVolumechange;
//    videoElement.onwaiting = onWaiting;
}

function playing(event) {
    var videoElement = event.target;
    handlePlayingVideoElement(videoElement);
}

function onFullScreen(event) {
    var videoElement = event.target;
    handlePlayingVideoElement(videoElement);
}

function handlePlayingVideoElement(videoElement) {
    if (videoElement.parentElement == null)
    {
        return;
    }
    
    if (parent)
    {
        try {
            parent.currentVideoElement = videoElement;
        } catch(err) {}
    }
    else
    {
        currentVideoElement = videoElement;
    }

//    videoElement.playbackRate = 0;
//    videoElement.removeAttribute('webkit-playsinline');
    videoElement.pause();

    var src = videoElement.src;

    if (!src) {
        src = videoElement.getElementsByTagName('source')[0].src;
    }

    if (!src) {
        //...
    }

    var jsonResult = {};
    var rect = videoElement.getBoundingClientRect();
    jsonResult[src] = [rect.left, rect.top, rect.width, rect.height, videoElement.currentTime, videoElement.title];
    webkit.messageHandlers.videoPlayHandler.postMessage(jsonResult);
}

var observer = new MutationObserver(function(mutations) {
    mutations.forEach(function(mutation) {
        if (mutation.type == 'childList' && mutation.addedNodes.length) {
            for (i = 0; i < mutation.addedNodes.length; i++) {

                node = mutation.addedNodes[i];

                if (node.tagName == 'VIDEO') {
                    prepareVideoElement(node);
                }
                      
                if (node.tagName == 'IFRAME') {
                    iframe = node;
                    var innerDoc = iframe.contentDocument || iframe.contentWindow.document;
                    prepareVideoElementInDocument(node);
                }

                if (node.getElementsByTagName) {
                    var arrayOfVideoElements = node.getElementsByTagName('video');

                    for (var j = 0; j < arrayOfVideoElements.length; j++) {
                        var videoElement = arrayOfVideoElements[j];
                        prepareVideoElement(videoElement);
                    }
                }
            }
        }
    });
});

var observerConfig = {
    attributes: false,
    childList: true,
    characterData: false,
    subtree: true,
    attributeOldValue: false,
    characterDataOldValue: false
};

try {
    prepareAllElements(document);
} catch(err) {}

try {
    observer.observe(document.getElementsByTagName('body')[0], observerConfig);
} catch(err) {}

var currentVideoElement = null;

function hideCurrentVideo(e) {
    if (currentVideoElement)
    {
        currentVideoElement.webkitExitFullScreen();
        currentVideoElement.pause();
    }
}

//---------------------------------------------
// All Events
//---------------------------------------------

function onAbort(event)
{
    webkit.messageHandlers.videoFreeHandler.postMessage('onAbort');
}

function onCanplay(event)
{
    webkit.messageHandlers.videoFreeHandler.postMessage('onCanplay');
}

function onCanplaythrough(event)
{
    webkit.messageHandlers.videoFreeHandler.postMessage('onCanplaythrough');
}

function onDurationchange(event)
{
    webkit.messageHandlers.videoFreeHandler.postMessage('onDurationchange');
}

function onEmptied(event)
{
    webkit.messageHandlers.videoFreeHandler.postMessage('onEmptied');
}

function onEnded(event)
{
    webkit.messageHandlers.videoFreeHandler.postMessage('onEnded');
}

function onError(event)
{
    webkit.messageHandlers.videoFreeHandler.postMessage('onError');
}

function onLoadeddata(event)
{
    webkit.messageHandlers.videoFreeHandler.postMessage('onLoadeddata');
}

function onLoadedmetadata(event)
{
    webkit.messageHandlers.videoFreeHandler.postMessage('onLoadedmetadata');
}

function onLoadstart(event)
{
    webkit.messageHandlers.videoFreeHandler.postMessage('onLoadstart');
}

function onPause(event)
{
    webkit.messageHandlers.videoFreeHandler.postMessage('onPause');
}

function onPlay(event)
{
    webkit.messageHandlers.videoFreeHandler.postMessage('onPlay');
}

function onPlaying(event)
{
    webkit.messageHandlers.videoFreeHandler.postMessage('onPlaying');
}

function onProgress(event)
{
    webkit.messageHandlers.videoFreeHandler.postMessage('onProgress');
}

function onRatechange(event)
{
    webkit.messageHandlers.videoFreeHandler.postMessage('onRatechange');
}

function onSeeked(event)
{
    webkit.messageHandlers.videoFreeHandler.postMessage('onSeeked');
}

function onSeeking(event)
{
    webkit.messageHandlers.videoFreeHandler.postMessage('onSeeking');
}

function onStalled(event)
{
    webkit.messageHandlers.videoFreeHandler.postMessage('onStalled');
}

function onSuspend(event)
{
    webkit.messageHandlers.videoFreeHandler.postMessage('onSuspend');
}

function onTimeupdate(event)
{
    webkit.messageHandlers.videoFreeHandler.postMessage('onTimeupdate');
}

function onVolumechange(event)
{
    webkit.messageHandlers.videoFreeHandler.postMessage('onVolumechange');
}

function onWaiting(event)
{
    webkit.messageHandlers.videoFreeHandler.postMessage('onWaiting');
}
